
'''
a short example demonstrating the Qt4agg figure options popup binded to the mouse click event
author: Peter Butterworth  


figureoptions.py requires PyQt v4.3 or superior installed
'''

import matplotlib; matplotlib.use("Qt4Agg")
import matplotlib.pyplot as plt
import matplotlib.patches
import matplotlib.backends.qt4_editor.figureoptions as figureoptions    
import numpy as np
assert plt.get_backend()=='Qt4Agg'    

x, y = np.arange(3), np.array([0, 2, 1])    
fig = plt.figure()
ax = fig.add_subplot(111)


## Shapes
e0=matplotlib.patches.Ellipse((0, 0), 4, 12, angle=0,  fill=False, ls='dashed', ec='k')
e2=matplotlib.patches.Ellipse((0, 0), 4, 12, angle=20, fill=True, alpha=0.4, ec='k', label='e2')
ax.add_patch(e0)
ax.add_patch(e2)
ax.fill(x, y, fill=False)

## Lines    
ax.plot(x, '-rx', label="y0")

## Texts
t1=ax.text(-5, -5, 't1')
t2=ax.text(0.5, 0.5, 't2')

## Axes
ax.set_title("Click on plot to open figure options editor")
ax.axis('equal')

## Legend
leg=ax.legend(loc=0)


def onclick(event): figureoptions.figure_edit(ax)    
cid = fig.canvas.mpl_connect('button_press_event', onclick)
plt.show()
